(* matrix.ml
 *
 * Copyright (C) 2006 Bertrand Mesot
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA 02110-1301, USA.
 *)

open Misc;;
(*-------------------------------------------------------------------------*)
let save_mat mat chan =
  let (m, n) = Gsl_matrix.dims mat in
  
  for i=0 to m-1 do
    for j=0 to n-1 do
      Printf.fprintf chan "%e " (Gsl_matrix.get mat i j)
    done;
    
    Printf.fprintf chan "\n"
  done;;
(*-------------------------------------------------------------------------*)
let load_mat mat input =
  let (nr, nc) = Gsl_matrix.dims mat in
  
  for i=0 to nr-1 do
    let vals = input_line_split input in

    for j=0 to nc-1 do
      Gsl_matrix.set mat i j (float_of_string vals.(j))
    done
  done;;
(*-------------------------------------------------------------------------*)
let disp_mat mat =
  let (m, n) = Gsl_matrix.dims mat in
  
  for i=0 to m-1 do
    for j=0 to n-1 do
      Printf.printf "%f " (Gsl_matrix.get mat i j)
    done;
    
    Printf.printf "\n"
  done;;
