(* misc.ml
 *
 * Copyright (C) 2006 Bertrand Mesot
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA 02110-1301, USA.
 *)

open Const;;
(*-------------------------------------------------------------------------*)
let input_line file =
  let str = input_line file in
  let str = Str.replace_first (Str.regexp "^[\t ]+") "" str in
  let str = Str.global_replace (Str.regexp "[\t ]+") " " str in
  Str.replace_first (Str.regexp "[\t ]+$") "" str;;
(*-------------------------------------------------------------------------*)
let input_line_split file =
  let str = input_line file in
  Array.of_list (Str.split (Str.regexp " ") str);;
(*-------------------------------------------------------------------------*)
let log_add x1 x2 =
  if x1 = x2 then
    x1 +. log_of_two
  else
    if x1 > x2 then 
      x1 +. Gsl_math.log1p (exp (x2 -. x1))
    else 
      x2 +. Gsl_math.log1p (exp (x1 -. x2));;
(*-------------------------------------------------------------------------*)
let mymax x =
  let v = ref x.(0)
  and i = ref 0
  and l = Array.length x in

  for k=1 to l-1 do
    if x.(k) > !v then
      begin
	v := x.(k);
	i := k;
      end
  done;

  (!v, !i);;
(*-------------------------------------------------------------------------*)
