(* random.ml
 *
 * Copyright (C) 2006 Bertrand Mesot
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA 02110-1301, USA.
 *)

let rng = Gsl_rng.make (Gsl_rng.default ());;
(*-------------------------------------------------------------------------*)
let set_seed s = Gsl_rng.set rng (Nativeint.of_float s);;
(*-------------------------------------------------------------------------*)
let randinit () =
  let s = (Unix.time ()) *. (float_of_int (Unix.getpid ())) /. 1e5 in
  set_seed s;;
(*-------------------------------------------------------------------------*)
let randval () = Gsl_rng.uniform rng;;
(*-------------------------------------------------------------------------*)
let randnval ?(cov=1.) () = Gsl_randist.gaussian rng (sqrt cov);;
(*-------------------------------------------------------------------------*)
let randgen p =
  let v = Gsl_rng.uniform rng in

  let rec loop s i =
    let lim = s +. p.(i) in
    if v < lim then
      i
    else
      loop lim (i+1)
  in
  loop 0. 0;;
(*-------------------------------------------------------------------------*)
